local L = LibStub("AceLocale-3.0"):GetLocale("Chinon")

local Portrait_Left = 8
local Portrait_Height = 24
local Portrait_Width = 24
local Nom_Margin = 8
local Nom_Left = Portrait_Left + Portrait_Width + Nom_Margin
local Nom_Height = Portrait_Height
local Icon_Margin = 8
local Icon_Width = 24
local Icon_Height = 24
local Text_Margin = 8
local Text_Width = 100
local Text_Height = Icon_Height
local Line_Height = Text_Height+4
local Time_Width = 60
local Popup_Width = Icon_Margin+Icon_Width+Text_Margin*2+Text_Width+Time_Width

ChinonDebuffs = CreateFrame("Frame",nil,SoinFrame)

function ChinonDebuffs:SetUnit(unit)
	self.unit = unit
	self.nom:SetTextColor(1,1,1)
	self.nom:SetText(UnitName(unit))
	SetPortraitTexture(self.portrait, unit)
	self:Show()
end

function ChinonDebuffs:UpdateSkin()
	Chinon:AppliquerFrameSkin(self, Chinon.apparence.frameSkin)
end
 
function ChinonDebuffs:Update()
	local cible=self.unit
	local i=1;
	local now = GetTime()
	
	
	for i,v in pairs(self.icon) do
		self.icon[i]:Hide()
		self.stacks[i]:Hide()
		self.text[i]:Hide()
		self.time[i]:Hide()
	end
	
	while 1 do
		local debuffName, debuffRank, debuffTexture, debuffApplications, debuffType,
			duration, expirationTime   =UnitDebuff(cible,i);
		if (not debuffName) then
			break;
		end
		local warn=false;
		
		local y = -(Icon_Margin+Nom_Margin+Nom_Height+Line_Height*(i-1))
		if (not self.icon[i]) then
			self.icon[i] = self:CreateTexture()
			self.icon[i]:SetPoint("TOPLEFT", Icon_Margin, y)
			self.icon[i]:SetWidth(Icon_Width)
			self.icon[i]:SetHeight(Icon_Height)
		end
		if (not self.text[i]) then
			self.text[i] = self:CreateFontString(nil)
			self.text[i]:SetFontObject("GameFontNormal");
			self.text[i]:SetWidth(Text_Width)
			self.text[i]:SetHeight(Text_Height)
			self.text[i]:SetPoint("TOPLEFT", Icon_Margin+Icon_Width+Text_Margin, y);
		end	
		if (not self.time[i]) then
			self.time[i] = self:CreateFontString(nil)
			self.time[i]:SetFontObject("GameFontNormal");
			self.time[i]:SetWidth(Time_Width)
			self.time[i]:SetHeight(Text_Height)
			self.time[i]:SetPoint("TOPLEFT", Popup_Width-Time_Width-Text_Margin, y);
		end	
		if (not self.stacks[i]) then
			self.stacks[i] = self:CreateFontString(nil)
			self.stacks[i]:SetFontObject("GameFontNormal");
			self.stacks[i]:SetPoint("CENTER", Icon_Margin+Icon_Width/2, y+Icon_Height/2)
			self.stacks[i]:SetTextColor(1,1,1)
		end
		self.icon[i]:Show()
		self.stacks[i]:Show()
		self.text[i]:Show()
		self.time[i]:Show()
		
		self.icon[i]:SetTexture(debuffTexture)
			
		if (Chinon.decurseLevel[debuffName]==2) then
			warn=true;
		end
		
		if (warn) then
			self.text[i]:SetTextColor(1,0,0)
		elseif (debuffType == "Magic") then
			self.text[i]:SetTextColor(0,0,1)
		elseif (debuffType == "Disease") then
			self.text[i]:SetTextColor(1,1,0)
		elseif (debuffType == "Curse") then
			self.text[i]:SetTextColor(1,0,1)
		elseif (debuffType == "Poison") then
			self.text[i]:SetTextColor(0,1,0)
		else
			self.text[i]:SetTextColor(1,1,1)
		end
		
		if (expirationTime>0) then
			self.time[i]:SetText(math.floor(expirationTime-now) .. " s")
		else
			self.time[i]:SetText("")
		end
		self.text[i]:SetText(debuffName)
		
		if (debuffApplications>0) then
			self.stacks[i]:SetText(debuffApplications)
			self.stacks[i]:Show()
		else
			self.stacks[i]:Hide()
		end
		i=i+1;
	end
	self:SetHeight((i-1)*Line_Height+Nom_Height+Nom_Margin*2+Icon_Margin)
end

function ChinonDebuffs:Init()
	self:SetBackdropColor(0.1,0.1,0,0.3)
	self:SetPoint("TOPLEFT",SoinFrame,"TOPRIGHT",0,0)
	self.nom = self:CreateFontString(nil);
	self.nom:SetFontObject("GameFontNormal");
	self.nom:SetPoint("TOPLEFT",Nom_Left,-Nom_Margin);
	self:SetScript("OnUpdate", self.Update)
	self.portrait = self:CreateTexture()
	self.portrait:SetPoint("TOPLEFT",Portrait_Left, -Nom_Margin)
	self.portrait:SetWidth(Portrait_Width)
	self.portrait:SetHeight(Portrait_Height)
	self:Hide()
	self.icon = {}
	self.text = {}
	self.stacks = {}
	self.time = {}
	self:SetWidth(Popup_Width)
--	self:UpdateSkin()
end


